import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ShopDealerOrder, ShopDealerOrderParam } from './model';

/**
 * 分页查询分销商订单记录表
 */
export async function pageShopDealerOrder(params: ShopDealerOrderParam) {
  const res = await request.get<ApiResult<PageResult<ShopDealerOrder>>>(
    '/shop/shop-dealer-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商订单记录表列表
 */
export async function listShopDealerOrder(params?: ShopDealerOrderParam) {
  const res = await request.get<ApiResult<ShopDealerOrder[]>>(
    '/shop/shop-dealer-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商订单记录表
 */
export async function addShopDealerOrder(data: ShopDealerOrder) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/shop-dealer-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商订单记录表
 */
export async function updateShopDealerOrder(data: ShopDealerOrder) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/shop-dealer-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商订单记录表
 */
export async function removeShopDealerOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/shop/shop-dealer-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商订单记录表
 */
export async function removeBatchShopDealerOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/shop/shop-dealer-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商订单记录表
 */
export async function getShopDealerOrder(id: number) {
  const res = await request.get<ApiResult<ShopDealerOrder>>(
    '/shop/shop-dealer-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
